#include "Browser.h"


DIR dir;
FILINFO fileinfo;	//File information
FRESULT res;
char filename[30][50];		//	File num,File name lenght
char *last_filename;
int browser_cursor=0,browser_paper=0;	//Browser pages
char* pstr;
char 	type[20];		//File Type
uint8_t file_sel=0;		//Selected files	
uint8_t key_flag=0;
uint8_t	Interface_flag=0;
uint8_t	SD_UART_flag=0;
uint8_t	SD_UART_Mode=0;
int	Mode_flag=0;
int file_Name_flag=0;
uint8_t file_num=0;
uint8_t fail_num=0;
uint8_t size_flag=0;
extern uint8_t flag_300ms;
/* Back Flag*/
extern uint8_t doBack_flag;  
extern char KEY_BACK_Value ;//stm32f1xx_it.c
#if _USE_LFN
    char lfn[20];           
#endif
void GREEN_LED_Turn(void)
{
	if(HAL_GPIO_ReadPin(GREEN_LED_GPIO_Port,GREEN_LED_Pin))
		LED_GREEN_0;
	else
		LED_GREEN_1;
}

void Browser_paper_clean_half(void)
{	uint8_t i=0,j=0;
	for(i=0;i<128;i++)
	{
		for(j=0;j<48;j++)
		{
				ssd1306_draw_point(i,j, 0);
		}
	}
}
void Browser_paper_clean_full(void)
{	uint8_t i=0,j=0;
	for(i=0;i<128;i++)
	{
		for(j=0;j<64;j++)
		{
				ssd1306_draw_point(i,j, 0);
		}
	}
}
unsigned char Browser_save_fileame(unsigned char* path)
{
	uint8_t num=0;
	res=f_opendir(&dir,(const TCHAR*)path);
	
		#if _USE_LFN
						fileinfo.lfname=lfn;
						fileinfo.lfsize = sizeof(lfn);
		#endif	
		
		if (res == FR_OK) 
		{	
			printf("\r\n"); 
			while(1)
			{
				res = f_readdir(&dir, &fileinfo);                   //Read a file in the directory
				if (res != FR_OK || fileinfo.fname[0] == 0) break;  //Exit if there is an error or if it reaches the end
				pstr=strrchr(*fileinfo.lfname ? fileinfo.lfname : fileinfo.fname,'.');				
				if(pstr==NULL)continue;				//Skip without suffix names
				pstr++;
				strcpy(type,pstr);
				
				if(strcasecmp(pstr,"BMP")==0)
				{
					strcpy(filename[num],*fileinfo.lfname ? fileinfo.lfname : fileinfo.fname);
					printf("<%d>:  ", num);//Print the path	
					printf("%s\r\n",  filename[num]);//Print file name	 
					num++;
				}
			} 
		 }
		return num;  	//Return file number
}
const char Model_selection[20] = {0,1,2,3,4,5,6,255,255,255,255,255};
// Change 255 if you don't want it displayed
/**************************************
// The meaning of the digital identifier, which corresponds to the distinction of the ink screen program below, is not consistent with the distinction of the ink screen of the base plate
// Change the order of the array above to change the selection order
// Note that the following variable ePaper_Quantity is incremented by 1 for each additional screen type
// The corresponding string array needs to be appended with the corresponding string
// String is a two-dimensional array, can't use variable to store two-dimensional array, not enough memory, open variable array in any place pay attention to memory size
0: 1.54
1: 2.13
2: 2.7
3: 2.9
4: 4.2
5: 7.5
67.5HD
This table corresponds to the following string and driver selection. If you need to modify, please change the following driver together
***************************************/
//Add 1 for each additional screen; note that total number of screens = ePaper_Quantity + 1
const int  ePaper_Quantity = 7;
const char Model_string[ePaper_Quantity+3][21] = {
    {"1.54 inch e-paper B"},//0
	{"2.13 inch e-paper"},//1
    {"2.7 inch e-paper"},//2
	{"2.9 inch e-paper"},//3
	{"4.2 inch e-paper"},//4
	{"7.5 inch e-paper"},//5
	{"7.5 inch e-paper HD"},//6
	{".........."},//Keep two more for debugging, prevent data from going out of bounds,
	{".........."},//
};
int Sort = 1;
void Browser_display(void)
{	
    /********************Read key value******************/		
	key_flag=ReadKey();
    if(Interface_flag==0)
	{
        /********************Display Function Options*****************/
		Browser_paper_clean_full();
		if(Mode_flag==0)
			ssd1306_display_string(0, 13,"NFC Test Demo", 12, 0);
		else 
			ssd1306_display_string(0, 13,"NFC Test Demo", 12, 1);
		if(Mode_flag==1)
			ssd1306_display_string(0, 25,"Update E-paper", 12, 0);
		else 
			ssd1306_display_string(0, 25,"Update E-paper", 12, 1);
		/********************Display basic interface******/
		ssd1306_display_string(0, 0,"Select Demo", 12, 1);
		ssd1306_draw_line(0,11,128,0);
		ssd1306_draw_bitmap(0, 48, c_chFont1608[95], 8, 16);
		ssd1306_display_string(10, 50,"UP", 12, 1);
		ssd1306_draw_bitmap(28, 48, c_chFont1608[96], 8, 16);
		ssd1306_display_string(38, 50,"DOWN", 12, 1);
		ssd1306_draw_bitmap(63, 52, c_chFont1608[97], 16, 8);
		ssd1306_display_string(77, 50,"BACK", 12, 1);
		ssd1306_draw_bitmap(102, 52, c_chFont1608[98], 16, 8);
		ssd1306_display_string(116, 52,"OK", 12, 1);
		ssd1306_draw_line(0,48,128,0);
		ssd1306_refresh_gram();
        /********************Key handler******/
        if(key_flag!=0)
        {
            if(key_flag==1)					//Up
            {	
                Mode_flag--;
                if(Mode_flag<0)
                {		
                    Mode_flag=1;
                }
            }
            else if(key_flag==2)			//Down
            {	
                Mode_flag++;
                if(Mode_flag>1)
                {
                    Mode_flag=0;
                }
            }
            if(key_flag==4)                 //Sure
            {
                if(Mode_flag==0)
                {		
                    Browser_paper_clean_full();
                    ssd1306_display_string(20,24,"NFC reading test", 12, 1);
                    ssd1306_draw_line(0,11,128,0);
                    ssd1306_draw_bitmap(18, 52, c_chFont1608[97], 16, 8);
                    ssd1306_display_string(32, 50,"BACK", 12, 1);
                    ssd1306_draw_bitmap(63, 48, c_chFont1608[95], 8, 16);
                    ssd1306_display_string(74, 50,"WakeUP", 12, 1);
                    ssd1306_draw_line(0,48,128,0);
                    ssd1306_refresh_gram();
                    while(1)
                    {
                        rfalWorker();
                        demoCycle();				//Enter NFC Test Demo
                        if(doBack_flag==1)
                        {
                            doBack_flag=0;
                            break;
                        }
                    }
                    rfalFieldOff();
                }
                else if(Mode_flag==1)
                {
                    Interface_flag++;
                }
                browser_cursor=0;
            }
        }
    }
    else if(Interface_flag==1)
	{
		/********************Display E-paper Size Options*****************/
		Browser_paper_clean_full();
		for(int k=0;k<ePaper_Quantity;k++){
			if(browser_cursor%3 ==0 ){
				ssd1306_display_string(10, 13,Model_string[Model_selection[browser_cursor]], 12, 0);//
				//lookup table for string
			}else  if(Model_selection[browser_cursor-browser_cursor%3] < ePaper_Quantity) {
				ssd1306_display_string(10, 13,Model_string[Model_selection[browser_cursor-browser_cursor%3]], 12, 1);
			}
			
			if(browser_cursor%3 ==1){
				ssd1306_display_string(10, 25,Model_string[Model_selection[browser_cursor]], 12, 0);
			}else if(Model_selection[browser_cursor-browser_cursor%3+1] < ePaper_Quantity) {
				// No extra strings on the last page
				ssd1306_display_string(10, 25,Model_string[Model_selection[browser_cursor-browser_cursor%3+1]], 12, 1);
				// Get different strings under different conditions,
				/*
                    Position //0, 1, 2
                    +0 +1 +2 corresponds to the number %3 +0
                    +1 +0 -1 corresponds to the number %3 +1
                    +2 +1 +0 corresponds to the number %3 +2
                */
			}
			
			if(browser_cursor%3 == 2)
				ssd1306_display_string(10, 37,Model_string[Model_selection[browser_cursor]], 12, 0);
			else if(Model_selection[browser_cursor-browser_cursor%3+2] < ePaper_Quantity) 
				ssd1306_display_string(10, 37,Model_string[Model_selection[browser_cursor-browser_cursor%3+2]], 12, 1);
		}

		/********************Display basic interface******/
		ssd1306_display_string(0, 0,"Select E-paper Size", 12, 1);
		ssd1306_draw_line(0,11,128,0);
		ssd1306_draw_bitmap(0, 48, c_chFont1608[95], 8, 16);
		ssd1306_display_string(10, 50,"UP", 12, 1);
		ssd1306_draw_bitmap(28, 48, c_chFont1608[96], 8, 16);
		ssd1306_display_string(38, 50,"DOWN", 12, 1);
		ssd1306_draw_bitmap(63, 52, c_chFont1608[97], 16, 8);
		ssd1306_display_string(77, 50,"BACK", 12, 1);
		ssd1306_draw_bitmap(102, 52, c_chFont1608[98], 16, 8);
		ssd1306_display_string(116, 52,"OK", 12, 1);
		ssd1306_draw_line(0,48,128,0);
		ssd1306_refresh_gram();
		/********************Key handler******/
		if(key_flag!=0)
			{		
				if(key_flag==1)					//Up
				{	
					browser_cursor--;
					if(browser_cursor<0)
					{		
						browser_cursor=ePaper_Quantity-1;
					}
				}
				else if(key_flag==2)					//Down
				{	
					browser_cursor++;
					if(browser_cursor>=ePaper_Quantity)
					{
						browser_cursor=0;
					}
				}
				else if(key_flag==3)					//BACK
				{
					Interface_flag--;							
				}
				if(key_flag==4)
				{
					Interface_flag++;							//Next interface
					size_flag=Model_selection[browser_cursor];			//Selected E-paper Size
					printf("%d :%s \r\n",size_flag,Model_string[size_flag]);
					file_Name_flag = 0;
                    browser_paper = 0;
					Sort = 1;
                    SD_UART_Mode=0;
				}
				printf("browser_cursor= %d\r\n",browser_cursor);
		}
	}
	else if(Interface_flag==2)
	{	
        /********************Display Function Options*****************/
		Browser_paper_clean_full();
		if(SD_UART_Mode==0)
			ssd1306_display_string(0, 13,"Update E-paper SD", 12, 0);
		else 
			ssd1306_display_string(0, 13,"Update E-paper SD", 12, 1);
		if(SD_UART_Mode==1)
			ssd1306_display_string(0, 25,"Update E-paper UART", 12, 0);
		else 
			ssd1306_display_string(0, 25,"Update E-paper UART", 12, 1);
        
        /********************Display basic interface******/
		ssd1306_display_string(0, 0,"Select Demo", 12, 1);
		ssd1306_draw_line(0,11,128,0);
		ssd1306_draw_bitmap(0, 48, c_chFont1608[95], 8, 16);
		ssd1306_display_string(10, 50,"UP", 12, 1);
		ssd1306_draw_bitmap(28, 48, c_chFont1608[96], 8, 16);
		ssd1306_display_string(38, 50,"DOWN", 12, 1);
		ssd1306_draw_bitmap(63, 52, c_chFont1608[97], 16, 8);
		ssd1306_display_string(77, 50,"BACK", 12, 1);
		ssd1306_draw_bitmap(102, 52, c_chFont1608[98], 16, 8);
		ssd1306_display_string(116, 52,"OK", 12, 1);
		ssd1306_draw_line(0,48,128,0);
		ssd1306_refresh_gram();
        /********************Key handler******/
        if(key_flag!=0)
        {
            if(key_flag==1)					//Up
            {	SD_UART_Mode--;
                if(SD_UART_Mode<0)
                {		
                    SD_UART_Mode=1;
                }
            }
            else if(key_flag==2)					//Down
            {	SD_UART_Mode++;
                if(SD_UART_Mode>1)
                {
                    SD_UART_Mode=0;
                }
            }
            if(key_flag==3)      //BACK
            {	
                SD_UART_Mode=0;
                Interface_flag--;
            }
            if(key_flag==4)
            {
                if(SD_UART_Mode==0)
                {
                    Interface_flag++;							
                    SD_UART_flag = 0;
//                    printf("SD_UART_flag = %d\r\n",SD_UART_flag);
                    
                    while(1)
                    {
                        key_flag = 0;
                        if(!SDCard_Init()){	
                            LED_RED_1;
                            Browser_paper_clean_full();
                            ssd1306_display_string(26, 10,"SD Card Error!", 12, 1);
                            ssd1306_display_string(0,22,"Press the Back key to exit and press another key to try again", 12, 1);
                            ssd1306_refresh_gram();
                        }else {	
                            LED_RED_0;
                            file_num = Browser_save_fileame("0:");
                            break;
                        }
                        do{
                            key_flag = ReadKey();
                        }while(!key_flag);
                        if(key_flag == 3)
                        {
                            SD_UART_Mode=0;
                            LED_RED_0;
                            Interface_flag--;
                            break;
                        }
                    }
                }
                else if(SD_UART_Mode==1)
                {
                    Interface_flag++;							   
                    SD_UART_flag = 1;
//                    printf("SD_UART_flag = %d\r\n",SD_UART_flag);
                }
            }
        }
    }
    else if((Interface_flag==3) || (Interface_flag==4) || (Interface_flag==5))
	{	
        if(!SD_UART_flag)
        {
            
            Browser_display_SD();
        }
        else
        {
            Browser_display_Uart();
        }
    }
	else if(Interface_flag==6)
	{	
	//3.Refresh the picture in RAM to e-Paper
		if(flag_300ms==1)
		{
			rfalFieldOff();
			flag_300ms=0;
			LED_GREEN_1;
		}
		else if(flag_300ms==2)
		{
			Start_Dawring();
			flag_300ms=0;
			LED_GREEN_0;
		}
		if(key_flag==3)
		{	
			LED_GREEN_0;
			Interface_flag=1;
            rfalFieldOff();
		}
	}
}

void Browser_display_SD(void)
{	
    if(Interface_flag==3)
	{	
		/********************Display file*****************/	
		// Sort
		// Note that the current image will be saved after reselecting the image after refreshing, and the image will automatically jump to the image after reselecting the ink screen
		//
		char count=0;
		char TIMP[50];
		if(Sort == 1){
			for(char i = 0;i<50;i++){
				if(filename[i][0] == Model_string[size_flag][0]){//2.13
					if(filename[i][2] == Model_string[size_flag][2] && filename[i][3] == Model_string[size_flag][3]){//2.13
						// established
						strcpy(TIMP,filename[count]);
						strcpy(filename[count],filename[i]);
						strcpy(filename[i],TIMP);
						count++;
					}else if(filename[i][3] == Model_string[size_flag][2]){//2in1
						if(Model_string[size_flag][3] <= '9' && Model_string[size_flag][3] >= '0'){//
							if(filename[i][4] == Model_string[size_flag][3] ){
								// established
								strcpy(TIMP,filename[count]);
								strcpy(filename[count],filename[i]);
								strcpy(filename[i],TIMP);
								count++;
							}
						}else{// if not a number
							// established
							strcpy(TIMP,filename[count]);
							strcpy(filename[count],filename[i]);
							strcpy(filename[i],TIMP);
							count++;
						}
					}
				}
			}
			Sort = 0;
		}
		
		Browser_paper_clean_full();
		file_sel=browser_paper*3+file_Name_flag;
		if(file_Name_flag==0)
			ssd1306_display_string(10, 13,filename[browser_paper*3], 12, 0);
		else
			ssd1306_display_string(10, 13,filename[browser_paper*3], 12, 1);
		if(file_Name_flag==1)
			ssd1306_display_string(10, 25,filename[browser_paper*3+1], 12, 0);
		else
			ssd1306_display_string(10, 25,filename[browser_paper*3+1], 12, 1);
		if(file_Name_flag==2)
			ssd1306_display_string(10, 37,filename[browser_paper*3+2], 12, 0);
		else
			ssd1306_display_string(10, 37,filename[browser_paper*3+2], 12, 1);
		/********************Display basic interface******/
		ssd1306_display_string(0, 0,"Select BMP Picture", 12, 1);
		ssd1306_draw_line(0,11,128,0);
		ssd1306_draw_bitmap(0, 48, c_chFont1608[95], 8, 16);
		ssd1306_display_string(10, 50,"UP", 12, 1);
		ssd1306_draw_bitmap(28, 48, c_chFont1608[96], 8, 16);
		ssd1306_display_string(38, 50,"DOWN", 12, 1);
		ssd1306_draw_bitmap(63, 52, c_chFont1608[97], 16, 8);
		ssd1306_display_string(77, 50,"BACK", 12, 1);
		ssd1306_draw_bitmap(102, 52, c_chFont1608[98], 16, 8);
		ssd1306_display_string(116, 52,"OK", 12, 1);
		ssd1306_draw_line(0,48,128,0);
		ssd1306_refresh_gram();
		/********************Key handler******/
		if(key_flag!=0){		
				if(key_flag==1){				//up
					file_Name_flag--;
					if(file_Name_flag<0){		
						file_Name_flag=2;
						browser_paper--;	
						if(browser_paper<0){
							browser_paper=file_num/3;
							file_Name_flag=file_num%3-1;
						}
					}
				}else if(key_flag==2){					//down
					file_Name_flag++;
					if((browser_paper*3+file_Name_flag)>=file_num)			//Last file
					{
						file_Name_flag=0;
						browser_paper=0;
					}else if(file_Name_flag>2){
						file_Name_flag=0;
						if((browser_paper*3-1)<file_num){
							browser_paper++;
						}else{
							browser_paper=0;
						}
					}
				}else if(key_flag==3){				//back
                    browser_paper = 0;
					file_Name_flag = 0;
					Interface_flag--;							//Last interface
				}else if(key_flag==4){
					Interface_flag++;							//Next interface
					Browser_paper_clean_full();
					ssd1306_display_string(10, 8,"Whether to go ahead and make a choice?", 12, 1);
					ssd1306_draw_bitmap(23, 52, c_chFont1608[97], 16, 8);
					ssd1306_display_string(37, 50,"BACK", 12, 1);
					ssd1306_draw_bitmap(72, 52, c_chFont1608[98], 16, 8);
					ssd1306_display_string(86, 52,"OK", 12, 1);
					ssd1306_refresh_gram();
				}
				key_flag=0;
		}
	}else if(Interface_flag==4){						//Confirmation interface
				Browser_paper_clean_full();
				ssd1306_display_string(10, 8,"Whether to go ahead and make a choice?", 12, 1);
				ssd1306_draw_bitmap(23, 52, c_chFont1608[97], 16, 8);
				ssd1306_display_string(37, 50,"BACK", 12, 1);
				ssd1306_draw_bitmap(72, 52, c_chFont1608[98], 16, 8);
				ssd1306_display_string(86, 52,"OK", 12, 1);
				ssd1306_refresh_gram();
				if(key_flag==3){
					Interface_flag--;							//Previous interface
					Browser_paper_clean_full();
					/********************Display basic interface******/
					ssd1306_draw_bitmap(0, 48, c_chFont1608[95], 8, 16);
					ssd1306_display_string(10, 50,"UP", 12, 1);
					ssd1306_draw_bitmap(28, 48, c_chFont1608[96], 8, 16);
					ssd1306_display_string(38, 50,"DOWN", 12, 1);
					ssd1306_draw_bitmap(63, 52, c_chFont1608[97], 16, 8);
					ssd1306_display_string(77, 50,"BACK", 12, 1);
					ssd1306_draw_bitmap(102, 52, c_chFont1608[98], 16, 8);
					ssd1306_display_string(116, 52,"OK", 12, 1);
					ssd1306_draw_line(0,48,128,0);
				}else if(key_flag==4){
					Interface_flag++;							//Next interface
				}
				key_flag=0;
	}
	else if(Interface_flag==5)						//Start drawing interface
	{
		  /*show sd card pic*/
        //1.Initialize the SD card
		while(1){
			if(!SDCard_Init())
			{	LED_RED_1;
				Browser_paper_clean_full();
				ssd1306_display_string(26, 10,"SD Card Error!", 12, 1);
                ssd1306_display_string(0,22,"Press the Back key to exit and press another key to try again", 12, 1);
				ssd1306_refresh_gram();
			}
			else 
			{	LED_RED_0;
				Browser_paper_clean_full();
				ssd1306_display_string(5, 16,"Reading BMP picture    data from RAM...", 12, 1);
				ssd1306_refresh_gram();
				break;
			}
			do{
                key_flag = ReadKey();
            }while(!key_flag);
            if(key_flag == 3)
            {
                LED_RED_0;
                Interface_flag--;
                break;
            }
		}
    //2.Read BMP pictures into RAM
		if(last_filename!=filename[file_sel]){
			printf("file_sel = %s\r\n",filename[file_sel]);
			SDCard_ReadBMP(filename[file_sel]);
			if(KEY_BACK_Value == 1){
				Interface_flag = 2;
				KEY_BACK_Value = 0; 
			}else{
				last_filename=filename[file_sel];
			}
		}else{
			HAL_Delay(200);
		}
		/* Open TIM3 Interrupt */	
		HAL_TIM_Base_Start_IT(&htim3); 
		Interface_flag++;
		Browser_paper_clean_full();
		ssd1306_display_string(5, 16,"Please approach the e-paper or press back     key to exit.", 12, 1);
		ssd1306_refresh_gram();
	}
}

void Browser_display_Uart(void)
{
    if(Interface_flag==3)
    {
        char flag;
        Browser_paper_clean_full();
        ssd1306_display_string(5, 16,"Please transmit the image file via serial        port", 12, 1);
        ssd1306_refresh_gram();
        flag = Uart_Read_BMP(size_flag);
        if(flag)
        {
            Browser_paper_clean_full(); 
            if(flag == 1)
            {
                printf("transmission is interrupted\r\n");
                ssd1306_display_string(20,32,"transmission is        interrupted", 12, 1);
            }
            else
            {
                printf("BMP Size mismatch\r\n");
                ssd1306_display_string(10,32,"BMP Size mismatch", 12, 1);
            }
            printf("Press any key to exit\r\n");
            ssd1306_display_string(0,16,"Press any key to exit", 12, 1);
            ssd1306_refresh_gram();
            DEV_Delay_ms(200);
            while(1)
            {
                key_flag=ReadKey();
                if(key_flag!=0)
                {
                    LED_RED_0;
                    LED_GREEN_0;
                    
                    if(!SD_UART_flag)
                        Interface_flag=3;
                    else
                        Interface_flag=2;
                    return;
                }
            }
        }
        if(KEY_BACK_Value == 1){
            Interface_flag = 1;
            KEY_BACK_Value = 0; 
            return;
        }
        /* Open TIM3 Interrupt */	
        HAL_TIM_Base_Start_IT(&htim3); 
        Interface_flag = Interface_flag + 3;
        Browser_paper_clean_full();
        ssd1306_display_string(5, 16,"Please approach the e-paper or press back     key to exit.", 12, 1);
        ssd1306_refresh_gram();
    }
}

const int length[ePaper_Quantity+1]= {100,250,176,148,250,250,120};
void Read_RAM(uint32_t i,uint8_t *buf)
{
	uint8_t j;

	/******************************
        01.54B  100 
		1: 2.13   250
        2: 2.7    176
		3: 2.9    148
		4: 4.2    250
		5: 7.5    250
		67.5HD  120
	No more than 250 data can be sent at a time
	*******************************/
    if(size_flag == EPD_2IN13 || size_flag == EPD_2IN7 || size_flag == EPD_2IN9 || size_flag == EPD_4IN2)
    {
        for(j=0;j<length[size_flag];j++)
        {
            buf[j]=SPIRAM_RD_Byte(i*length[size_flag]+j);
        }
    }
    else if(size_flag == EPD_7IN5)
    {
        for(j=0;j<length[size_flag];j++)
        {
            buf[j]=~SPIRAM_RD_Byte(i*length[size_flag]+j);
        }
    }
}

const int length_V1[ePaper_Quantity+1]= {100,16,121,16,100,120,120};
void Read_RAM_V1(uint32_t i,uint8_t *buf)
{
	uint8_t j;

	/******************************
        01.54B  100 
		1: 2.13   16
        2: 2.7    121
		3: 2.9    16
		4: 4.2    100
		5: 7.5    120
		67.5HD  120
	No more than 250 data can be sent at a time
	*******************************/
    for(j=0;j<length_V1[size_flag];j++)
	{
        buf[3+j]=SPIRAM_RD_Byte(i*length_V1[size_flag]+j);
	}
}

void Read_RedRAM(uint32_t i,uint8_t *l)
{
	uint8_t j;
	for(j=0;j<length[size_flag];j++)
	{
		if(size_flag  == 6){//1.54B needs to flip the red image data, other screens do the underlying processing without flipping
			l[3+j]=~SPIRAM_RD_Byte(i*length[size_flag]+j+60000);
		}else {
			l[3+j]=SPIRAM_RD_Byte(i*length[size_flag]+j+60000);
		}
	}
}

void fail_interface(void)
{	
	Browser_paper_clean_full(); 
	ssd1306_display_string(26,8,"Update failed", 12, 1);
	ssd1306_display_string(0,24,"Please press any key to exit and try again", 12, 1);
	ssd1306_refresh_gram();
}

void Show_Progress(int progress)
{
		char Progress[4]={0,0,'%','\0'};
		Progress[0]=progress/10%10+'0';
		Progress[1]=progress/1%10+'0';
		ssd1306_display_string(40,16,"Progress:", 12, 1);
		ssd1306_display_string(58,32,Progress, 12, 1);
		ssd1306_refresh_gram();
}

uint8_t Start_Dawring(void)
{
    uint8_t NFC_Version=0;
    rfalWorker();
    HAL_Delay(100); 
    NFC_Version = RFLA_APDU_Send();
    if(NFC_Version)
    {
        if(NFC_Version == 1)
            Start_Dawring_V1();
        else if(NFC_Version == 2)
            Start_Dawring_V2();
        else
        {
            printf("NFC communication fails, press any button to exit\r\n");
            Browser_paper_clean_full(); 
            ssd1306_display_string(0,16,"  NFC communication    fails, press any      button to exit", 12, 1);
            ssd1306_refresh_gram();
            while(1)
            {
                key_flag=ReadKey();
                if(key_flag!=0)
                {
                    LED_RED_0;
                    LED_GREEN_0;
                    if(!SD_UART_flag)
                        Interface_flag=3;
                    else
                        Interface_flag=2;
                    
                    key_flag = 0;
                    return 1;
                }
            }
        }
    }  
}

uint8_t Start_Dawring_V2(void)
{
    uint8_t     buffer[250];
    uint16_t	progress=0,actrxlen[20],i=0;
    uint8_t     step=0;
    
    KEY_BACK_Value = 0;
    
    if(step == 0)
    {
        if(size_flag == EPD_2IN13)
        {
            step = 2;
            EPD_2IN13_V4_Init();
            ssd1306_fill_screen(37,15,96,46,1);
            ssd1306_fill_screen(38,16,95,45,0);
            for(i=0; i<16; i++)
            {
                progress=i*100/16;
                printf("Proress: %d %%\r\n", progress);
                Show_Progress(progress);
                Read_RAM(i, buffer);
                EPD_2IN13_V4_Display(i, buffer);
                GREEN_LED_Turn();//
                if(KEY_BACK_Value == 1){
                    step = 1;
                    break;
                }
            }
        }
        
        if(size_flag == EPD_2IN7)
        {
            step = 2;
            EPD_2IN7_V2_Init();
            ssd1306_fill_screen(37,15,96,46,1);
            ssd1306_fill_screen(38,16,95,45,0);
            for(i=0; i<33; i++)
            {
                progress=i*100/33;
                printf("Proress: %d %%\r\n", progress);
                Show_Progress(progress);
                Read_RAM(i, buffer);
                EPD_2IN7_V2_Display(i, buffer);
                GREEN_LED_Turn();//
                if(KEY_BACK_Value == 1){
                    step = 1;
                    break;
                }
            }
        }
        
        if(size_flag == EPD_2IN9)
        {
            step = 2;
            EPD_2IN9_V2_Init();
            ssd1306_fill_screen(37,15,96,46,1);
            ssd1306_fill_screen(38,16,95,45,0);
            for(i=0; i<32; i++)
            {
                progress=i*100/32;
                printf("Proress: %d %%\r\n", progress);
                Show_Progress(progress);
                Read_RAM(i, buffer);
                EPD_2IN9_V2_Display(i, buffer);
                GREEN_LED_Turn();//
                if(KEY_BACK_Value == 1){
                    step = 1;
                    break;
                }
            }
        }
        
        if(size_flag == EPD_4IN2)
        {
            step = 2;
            EPD_4IN2_V2_Init();
            ssd1306_fill_screen(37,15,96,46,1);
            ssd1306_fill_screen(38,16,95,45,0);
            for(i=0; i<60; i++)
            {
                progress=i*100/60;
                printf("Proress: %d %%\r\n", progress);
                Show_Progress(progress);
                Read_RAM(i, buffer);
                EPD_4IN2_V2_Display(i, buffer);
                GREEN_LED_Turn();//
                if(KEY_BACK_Value == 1){
                    step = 1;
                    break;
                }
            }
        }
        
        if(size_flag == EPD_7IN5)
        {
            step = 2;
            EPD_7IN5_V2_Init();
            ssd1306_fill_screen(37,15,96,46,1);
            ssd1306_fill_screen(38,16,95,45,0);
            for(i=0; i<192; i++)
            {
                progress=i*100/192;
                printf("Proress: %d %%\r\n", progress);
                Show_Progress(progress);
                Read_RAM(i, buffer);
                EPD_7IN5_V2_Display(i, buffer);
                GREEN_LED_Turn();//
                if(KEY_BACK_Value == 1){
                    step = 1;
                    break;
                }
            }
        }
    }
    if(step == 1)
    {
        step=0;
        rfalFieldOff();
        Browser_paper_clean_full(); 
        ssd1306_display_string(0,32,"Refresh interrupted", 12, 1);
        ssd1306_display_string(10,16,"  End with", 12, 1);
        ssd1306_refresh_gram();
        DEV_Delay_ms(200);
        while(1)
        {
            key_flag=ReadKey();
            if(key_flag!=0)
            {
                LED_RED_0;
                LED_GREEN_0;
                if(!SD_UART_flag)
                    Interface_flag=3;
                else
                    Interface_flag=2;
                key_flag = 0;
                return 1;
            }
        }

        
    }
    else
    {
        step=0;
        rfalFieldOff();
        printf("E-paper UPdate OK\r\n");
        printf("Press any key to exit\r\n");
        Browser_paper_clean_full(); 
        ssd1306_display_string(0,32,"Press any key to exit", 12, 1);
        ssd1306_display_string(10,16,"E-paper UPdate OK", 12, 1);
        ssd1306_refresh_gram();
        DEV_Delay_ms(200);
        while(1)
        {
            key_flag=ReadKey();
            if(key_flag!=0)
            {
                LED_RED_0;
                LED_GREEN_0;
                if(!SD_UART_flag)
                    Interface_flag=3;
                else
                    Interface_flag=2;
                
                key_flag = 0;
                return 1;
            }
        }
    }
    
}


/*******************************************************************
						1.54B key chain program
                        1.54B does not share the base plate, and the firmware is fixed
                        Special treatment
*******************************************************************/
char Start_Dawring_1in54B(void)
{
	uint8_t step=5;
	uint8_t step_5[128] = {0xcd,0x05,100};
	uint8_t step_4[2] = {0xcd,0x04};
	uint8_t step_6[2] = {0xcd,0x06};
	uint8_t rx[20] = {0};
	uint16_t actrxlen[20],i=0,progress=0;
	
	if(size_flag==0){
		step_5[2] = 100;
	}
	KEY_BACK_Value = 0;//interrupt response
	while(1){
		if(step == 5){
			
			Browser_paper_clean_full(); 
			if(size_flag==0){						//1.54inch B keychain
					for(i=0;i<50;i++){	
						rx[0]=1;rx[1]=1;
						Read_RAM_V1(i,step_5);
						rfalTransceiveBlockingTxRx(step_5,103,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);  // cd 05
						progress=i*100/100;
						printf("Proress: %d %%\r\n", progress);
						Show_Progress(progress);
						GREEN_LED_Turn();
						if(KEY_BACK_Value == 1){
									step = 15;// Data transfer was interrupted
									break;
						}
					}
			 }
			if(KEY_BACK_Value == 0){
				step = 6;
				rx[0]=1;rx[1]=1;
				printf("1.54_Step6\r\n");	
			}else {
				step = 15;
			}
			 
		}else if(step == 6){
			rfalTransceiveBlockingTxRx(step_4,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);										//cd 04																					
			GREEN_LED_Turn();
			step=7;
			if(rx[0]==0&&rx[1]==0){	
				rx[0]=1;rx[1]=1;
				step=7;
				printf("1.54_Step7\r\n");	
			}else{
				fail_num++;
				if(fail_num>10){
					printf("Update failed, please press any key to exit and try again.\r\n");
					fail_interface();
					LED_RED_1;
					step=14;
					fail_num=0;
					DEV_Delay_ms(200);
				}
			}
		}else if(step == 7){
			Browser_paper_clean_full(); 
			if(size_flag==0){							//1.54inch B keychain
					for(i=0;i<50;i++){	
						rx[0]=1;rx[1]=1;
						Read_RedRAM(i,step_5);// Send red image data
						rfalTransceiveBlockingTxRx(step_5,103,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);  // cd 05
						progress=i*100/100+50;
						printf("Proress: %d %%\r\n", progress);
						Show_Progress(progress);
						GREEN_LED_Turn();
						if(KEY_BACK_Value == 1){
									step = 15;// Data transfer was interrupted
									break;
						}
					}
			 }
			if(KEY_BACK_Value == 0){
				step = 8;
				rx[0]=1;rx[1]=1;
				printf("1.54_Step8\r\n");	
			}else {
				step = 15;
			}
		}else if(step == 8){
			// Send update instructions
			rfalTransceiveBlockingTxRx(step_6,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);										//cd 06																		
			GREEN_LED_Turn();
			if(rx[0]==0&&rx[1]==0){	
				rx[0]=1;rx[1]=1;
				step=9;
				printf("1.54_Step9\r\n");	
			}else{
				fail_num++;
				if(fail_num>10)
				{
					printf("Update failed, please press any key to exit and try again.\r\n");
					fail_interface();
					LED_RED_1;
					step=14;
					fail_num=0;
					DEV_Delay_ms(200);
				}
			}
		}else if(step == 9 ){
				return 0;
		}
		else if(step == 14){
			return 1;
		}
		else if(step == 15){// Hit short
			printf("step 15\r\n");
			return 2;
		}
	}
}


uint8_t Start_Dawring_V1(void)
{	
    ReturnCode        err;
    uint8_t           devIt = 0;
    rfalNfcaSensRes   sensRes;
    uint8_t						step=0,progress=0;
    uint8_t						step0[2]={0xcd,0x0d};				
    uint8_t						step1[3]={0xcd,0x00,10};				//select e-paper type and reset e-paper  						4:2.13inch e-Paper   7:2.9inch e-Paper  10:4.2inch e-Paper  14:7.5inch e-Paper
    uint8_t						step2[2]={0xcd,0x01};						//e-paper normal mode  type
    uint8_t						step3[2]={0xcd,0x02};						//e-paper config1
    uint8_t						step4[2]={0xcd,0x03};						//e-paper power on	
    uint8_t						step5[2]={0xcd,0x05};						//e-paper config2
    uint8_t						step6[2]={0xcd,0x06};						//EDP load to main
    uint8_t						step7[2]={0xcd,0x07};						//Data preparation
    uint8_t						step8[123]={0xcd,0x08,0x64};		//Data start command			2.13inch(0x10:Send 16 data at a time)    2.9inch(0x10:Send 16 data at a time)     4.2inch(0x64:Send 100 data at a time)  7.5inch(0x78:Send 120 data at a time)
    uint8_t						step9[2]={0xcd,0x18};					//e-paper power on
    uint8_t						step10[2]={0xcd,0x09};					//Refresh e-paper
    uint8_t						step11[2]={0xcd,0x0a};					//wait for ready
    uint8_t						step12[2]={0xcd,0x04};					//e-paper power off command
    uint8_t						step13[124]={0xcd,0x19,121};	
//	uint8_t						step13[2]={0xcd,0x0b};					//Judge whether the power supply is turned off successfully
//	uint8_t						step14[2]={0xcd,0x0c};					//The end of the transmission
    uint8_t						rx[20];
    uint16_t					actrxlen[20],i=0;

    KEY_BACK_Value = 0;
    devIt = 0;
    Browser_paper_clean_full(); 
    HAL_Delay(1000);
    printf("size_flag = %d\r\n",size_flag);
    while(1)
    {			
        if(step==0)
        {		
            printf("Step0");	
            rfalTransceiveBlockingTxRx(step0,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);		//cd 0d																						
            if(HAL_GPIO_ReadPin(GREEN_LED_GPIO_Port,GREEN_LED_Pin))
                LED_GREEN_0;
            else
                LED_GREEN_1;
            if(rx[0]==0&&rx[1]==0)
            {	rx[0]=1;rx[1]=1;
                step=1;
                printf("Step1\r\n");	
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    LED_RED_1;
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    
                }
            }
        }
        else if(step==1)
        {		
            Browser_paper_clean_full(); 
            // step1[2] Save the ink screen model
            // step8[2] Save the number of bytes sent at a time
            // step13[2] Save the number of bytes sent the number of bytes sent
            // General step8 send black image, step13 send red image
            if(size_flag==1)					//2.13inch
            {
                step1[2]= 4;
                step8[2]=16;
                step13[2] = 0;
            }
            else if(size_flag==3)			//2.9inch
            {	
                step1[2]= 7;
                step8[2]=16;
                step13[2] = 0;
            }
            else if(size_flag==4)			//4.2inch
            {
                step1[2]= 10;
                step8[2]=100;
                step13[2] = 0;
            }
            else if(size_flag==5)			//7.5inch
            {
                step1[2]= 14;
                step8[2]=120;
                step13[2] = 0;
            }else if(size_flag==2)			//2.7inch
            {
                step1[2]=16;
                step8[2]=121;
                // Blank data is sent for the first time, and all other data is changed to 0xff without being processed by the underlying layer
                step13[2] = 121;
                // Send the data for the second time, which is the real image data. If you don't send the previous 0xff, the output image at the end will be abnormally black
            }else if(size_flag==10)			//2.13inch B
            {
                step1[2]=5;   // Ink screen code EPD 2IN13BC is 5 
                step8[2]=106; // Length in bytes
                step13[2] = 106;
            }else if(size_flag==6)		
            {
                step1[2]=17;   
                step8[2]=120; // Length in bytes
                step13[2] = 0;
            }
            
            if(size_flag==0){
                rfalTransceiveBlockingTxRx(step1,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);		//cd 00   
            }
            else {
                rfalTransceiveBlockingTxRx(step1,3,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
            }
            ssd1306_display_string(20, 24,"E-paper config", 12, 1);
            ssd1306_refresh_gram();
            if(rx[0]==0&&rx[1]==0)
            {rx[0]=1;rx[1]=1;
                step=2;
                printf("Step2\r\n");	
                fail_num=0;
                DEV_Delay_ms(100);
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
            DEV_Delay_ms(10);
        }
        else if(step==2)
        {
            rfalTransceiveBlockingTxRx(step2,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);			//cd 01
            if(rx[0]==0&&rx[1]==0)
            {	rx[0]=1;rx[1]=1;
                step=3;
                printf("Step3\r\n");	
                fail_num=0;
                DEV_Delay_ms(100);
            }
            else
            {
                fail_num++;
                if(fail_num>50)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
            DEV_Delay_ms(100);
        }
        else if(step==3)
        {
            rfalTransceiveBlockingTxRx(step3,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);   //cd 02
            if(rx[0]==0&&rx[1]==0)	
            {
                rx[0]=1;rx[1]=1;
                step=4;
                printf("Step4\r\n");
                fail_num=0;
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
            DEV_Delay_ms(200);
        }
        else if(step==4)
        {
            rfalTransceiveBlockingTxRx(step4,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);    //cd 03
            if(size_flag==0){
                /*******************************************************************
                                                            1.54B key chain program
                *******************************************************************/
                printf("Start_Dawring_1in54B\r\n");
                char t= Start_Dawring_1in54B();
                    if(t == 0){
                        step=11;
                        //1.54B data transfer finished waiting for refresh
                    }else if(t == 1){
                        step=14;
                        //1.54B data transfer error
                    }else if(t ==2){
                        step = 15;
                    }
                /*******************************************************************
                                                            1.54B keychain program END
                *******************************************************************/
                }
            if(rx[0]==0 && rx[1]==0){
                if(KEY_BACK_Value == 0){
                    fail_num=0;
                    rx[0]=1;rx[1]=1;
                    step=5;
                    printf("Step5\r\n");
                }else {
                    step = 15;
                }
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
        }
        else if(step==5)
        {
            rfalTransceiveBlockingTxRx(step5,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);			//cd 05
                if(rx[0]==0&&rx[1]==0){
                    rx[0]=1;rx[1]=1;
                    step=6;
                    printf("Step6\r\n")	;
                    fail_num=0;
                    DEV_Delay_ms(100);
                }
                else
                {
                    fail_num++;
                    if(fail_num>30)
                    {
                        printf("Update failed, please press any key to exit and try again.\r\n");
                        fail_interface();
                        step=14;
                        fail_num=0;
                        DEV_Delay_ms(200);
                        LED_RED_1;
                    }
                }
                DEV_Delay_ms(10);
        }
        else if(step==6)
        {
            rfalTransceiveBlockingTxRx(step6,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);       //cd 06
            if(rx[0]==0&&rx[1]==0){	
            rx[0]=1;rx[1]=1;
                step=7;
                printf("Step7\r\n");
                fail_num=0;
                DEV_Delay_ms(100);
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
        }
        else if(step==7)
        {		
            Browser_paper_clean_full(); 
            rfalTransceiveBlockingTxRx(step7,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);      //cd 07
            ssd1306_display_string(5,16,"Start data transfer", 12, 1);
            ssd1306_refresh_gram();
            if(rx[0]==0&&rx[1]==0){
                rx[0]=1;rx[1]=1;
                step=8;
                printf("Step8\r\n");
                fail_num=0;
            }
            else
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(200);
                    LED_RED_1;
                }
            }
        }
        else if(step==8)																																								//cd 08
        {		
            Browser_paper_clean_full(); 
            if(size_flag==1)							//2.13inch
            {
                for(i=0;i<250;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    rfalTransceiveBlockingTxRx(step8,19,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*100/250;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }
            else if(size_flag==3)
            {
             for(i=0;i<296;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    rfalTransceiveBlockingTxRx(step8,19,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*100/296;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }
            else if(size_flag==4)					//4.2inch
            {
                for(i=0;i<150;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    rfalTransceiveBlockingTxRx(step8,103,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*100/150;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }
            else if(size_flag==5)			//7.5inch
            {
                    for(i=0;i<400;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    rfalTransceiveBlockingTxRx(step8,123,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*100/400;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();
                    HAL_Delay(6);
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }else if(size_flag==10)			//2.13inch B
            {
                    for(i=0;i<26;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    rfalTransceiveBlockingTxRx(step8,109,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*50/26;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }else if(size_flag==6)			//7.5HD
            {
                
                for(i=0;i<484;i++)
                {	rx[0]=1;rx[1]=1;
                    Read_RAM_V1(i,step8);
                    //memset(&step8[3], 0xf0, 120);
                    rfalTransceiveBlockingTxRx(step8,123,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*100/484;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();//
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
                memset(&step8[3], 0xff, 120);
                rfalTransceiveBlockingTxRx(step8,110+3,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
            }else if(size_flag==2){			//2.7inch
                for(i=0;i<48;i++){	
                    rx[0]=1;rx[1]=1;
                    //Read_RAM_V1(i,step8);
                    memset(&step8[3], 0xFF, 121);
                    rfalTransceiveBlockingTxRx(step8,124,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*50/48;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();//
                    if(KEY_BACK_Value == 1){
                        step = 15;
                        break;
                    }
                }
            }
            if(KEY_BACK_Value == 0){
                rx[0]=1;rx[1]=1;
                step=9;
                printf("Step9\r\n");
            }else {
                step = 15;
            }
        }
        else if(step==9)
        {		
            if(size_flag==1 || size_flag==3 || size_flag==4 || size_flag==5 || size_flag ==7){
                rfalTransceiveBlockingTxRx(step9,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);//cd 18
                // black and white screen sending bottom board side is also blocked, no effect. 2.7 Except
                if(rx[0]!=0||rx[1]!=0)
                {
                        fail_num++;
                        if(fail_num>10)
                        {
                            printf("Update failed, please press any key to exit and try again.\r\n");
                            fail_interface();
                            step=14;
                            fail_num=0;
                            DEV_Delay_ms(500);
                            LED_RED_1;
                        }
                    }
                    else
                        fail_num=0;
                    
                rx[0]=1;rx[1]=1;
                step=10;
                printf("Step10\r\n");
            }else if(size_flag==10 ||  size_flag==2){
                rfalTransceiveBlockingTxRx(step9,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);	//cd 18
                //rx[0]=1;rx[1]=1;
                step=19;
                printf("Step19\r\n");
            
            }
        }
        else if(step==10)
        {
            rfalTransceiveBlockingTxRx(step10,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);//cd 09 Refresh instruction
            if(rx[0]!=0||rx[1]!=0)
            {
                fail_num++;
                if(fail_num>10)
                {
                    printf("Update failed, please press any key to exit and try again.\r\n");
                    fail_interface();
                    step=14;
                    fail_num=0;
                    DEV_Delay_ms(500);
                    LED_RED_1;
                }
            }
            else
                fail_num=0;
            rx[0]=1;rx[1]=1;
            step=11;
            printf("Step11\r\n");
            DEV_Delay_ms(200);
        }
        else if(step==11)
        {		
            if(size_flag==10 || size_flag==0){// black and white red screen refresh time is longer wait first
                    DEV_Delay_ms(10000);
            }else if(size_flag==6){
                DEV_Delay_ms(1000);
            }
            while(1)
            {	rx[0]=1;rx[1]=1;
                if(size_flag==0){
                    rfalTransceiveBlockingTxRx(step8,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    //1.54B send 0xcd 0x08
                }else{
                    rfalTransceiveBlockingTxRx(step11,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);										//cd 0a
                }
                Browser_paper_clean_full(); 
                if(rx[0]==0xff&&rx[1]==0)
                {
                    printf("E-paper Reflash OK\r\n");
                    ssd1306_display_string(10,16,"E-paper Reflash OK", 12, 1);
                    ssd1306_refresh_gram();
                    fail_num=0;
                    step=12;
                    printf("Step12\r\n");
                    DEV_Delay_ms(200);
                    break;
                }
                else
                {
                    if(fail_num>70)
                    {
                        printf("Update failed, please press any key to exit and try again.\r\n");
                        fail_interface();
                        step=14;
                        fail_num=0;
                        DEV_Delay_ms(500);
                        LED_RED_1;
                        break;
                    }
                    else
                    {	fail_num++;
                        printf("E-paper Reflashing, Waiting\r\n");
                        DEV_Delay_ms(100);
                    }
                }			
            }
        }
        else if(step==12)
        {
            rfalTransceiveBlockingTxRx(step12,2,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);										//cd 04
            rx[0]=1;rx[1]=1;
            step=13;
            printf("Step13\r\n");
            DEV_Delay_ms(200);
        }
        else if(step==13)
        {		
            rx[0]=1;rx[1]=1;
            step=14;
            printf("Step13\r\n");
            printf("E-paper UPdate OK\r\n");
            printf("Press any key to exit\r\n");
            Browser_paper_clean_full(); 
            ssd1306_display_string(0,32,"Press any key to exit", 12, 1);
            ssd1306_display_string(10,16,"E-paper UPdate OK", 12, 1);
            ssd1306_refresh_gram();
            DEV_Delay_ms(200);
        }
        else if(step==14)
        {	
            rfalFieldOff();
            key_flag=ReadKey();
            if(key_flag!=0)
            {
                LED_RED_0;
                LED_GREEN_0;
                step=0;
                if(!SD_UART_flag)
                    Interface_flag=3;
                else
                    Interface_flag=2;
                key_flag = 0;
                return 1;
            }
        }else if(step==15)
        {	
            printf("step 14\r\n");
            rfalFieldOff();
            Browser_paper_clean_full(); 
            ssd1306_display_string(0,32,"Refresh interrupted", 12, 1);
            ssd1306_display_string(10,16,"  End with", 12, 1);
            ssd1306_refresh_gram();
            DEV_Delay_ms(1000);
            LED_RED_0;
            LED_GREEN_0;
            step=0;
            if(!SD_UART_flag)
                Interface_flag=3;
            else
                Interface_flag=2;
            key_flag = 0;
            return 1;
        }
        else if(step==19)
        {	
            if(size_flag==2 ){
                for(i=0;i<48;i++){	
                    rx[0]=1;rx[1]=1; 
                    Read_RAM_V1(i,step13);
                    rfalTransceiveBlockingTxRx(step13,124,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);	//CD 19
                    progress=i*50/48+50;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();// Green light blinks
                }
            }else if(size_flag==10){
                for(i=0;i<26;i++){	
                    rx[0]=1;rx[1]=1;
                    Read_RedRAM(i,step13);
                    //memset(&step13[3], 0xfE, 106);
                    rfalTransceiveBlockingTxRx(step13,109,rx,20,actrxlen,RFAL_TXRX_FLAGS_DEFAULT,2157+2048);
                    progress=i*50/26+50;
                    printf("Proress: %d %%\r\n", progress);
                    Show_Progress(progress);
                    GREEN_LED_Turn();// Green light blinks
                }
            }
            rx[0]=1;rx[1]=1;
            step=10;
            printf("Step10\r\n");
        }
        
        if(step==14||HAL_GPIO_ReadPin(GREEN_LED_GPIO_Port,GREEN_LED_Pin))
                LED_GREEN_0;
            else
                LED_GREEN_1;
    }
	//printf("END\r\n");
	return 0;
}


